unit hXxmlUtils;

interface

uses
  XMLIntf;

function xmlNodeHasChildNode(node: IXMLNode; nodeName: WideString; recusive: boolean = false): boolean;
function xmlGetChildTextDef(node: IXMLNode; nodeName: WideString; default: wideString): WideString;
function xmlGetChildBoolDef(node: IXMLNode; nodeName: WideString; default: boolean): boolean;
function xmlGetChildIntDef(node: IXMLNode; nodeName: WideString; default: integer): integer;
function xmlNodeCountByName(node: IXMLNode; childName: WideString): integer;

implementation

function xmlNodeHasChildNode(node: IXMLNode; nodeName: WideString; recusive: boolean = false): boolean;
var
  ii: integer;
begin
  result := false;
  if not node.HasChildNodes then
    exit;
  for ii := 0 to node.ChildNodes.Count -1 do
    begin
    if node.ChildNodes[ii].HasChildNodes then
      begin
      if xmlNodeHasChildNode(node.ChildNodes[ii], nodeName) then
        begin
        result := true;
        break;
        end; //if xmlHasChildNode(node.ChildNodes[ii], nodeName) then
      end; //if node.ChildNodes[ii].HasChildNodes then
    if node.ChildNodes[ii].NodeName = nodeName then
      begin
      result := true;
      break;
      end; //if node.ChildNodes[ii].NodeName = nodeName then
    end; //for ii := 0 to node.ChildNodes.Count -1 do
end;

function xmlGetChildTextDef(node: IXMLNode; nodeName: WideString; default: wideString): WideString;
begin
  if xmlNodeHasChildNode(node, nodeName) then
    result := node.ChildNodes[nodeName].Text
  else
    result := default;
end;

function xmlGetChildBoolDef(node: IXMLNode; nodeName: WideString; default: boolean): boolean;
begin
  if xmlNodeHasChildNode(node, nodeName) then
    result := node.ChildNodes[nodeName].NodeValue
  else
    result := default;
end;

function xmlGetChildIntDef(node: IXMLNode; nodeName: WideString; default: integer): integer;
begin
  if xmlNodeHasChildNode(node, nodeName) then
    result := node.ChildNodes[nodeName].NodeValue
  else
    result := default;
end;

function xmlNodeCountByName(node: IXMLNode; childName: WideString): integer;
var
  ii: integer;
begin
  result := 0;
  for ii:= 0 to node.ChildNodes.Count - 1 do
    begin
    if node.ChildNodes[ii].NodeName = childName then
      inc(result);
    end;
end;

end.
